let webSocketServer = null;

// WebSocket ------------------------------------------------------------------

function agregarMensaje(texto, clase) {
  const mensaje = document.createElement('p');
  mensaje.classList.add('mensaje');
  mensaje.classList.add(clase);
  mensaje.innerText = texto;

  const mensajes = document.getElementById('mensajes');
  mensajes.appendChild(mensaje);
}

function webSocketOpened() {
  const status = document.getElementById('estado');
  status.className = 'ok';
  status.innerText = 'Conectado';
}

function webSocketClosed(evento) {
  const status = document.getElementById('estado');
  status.className = 'error';
  status.innerText = 'Desconectado';

  agregarMensaje(`Desconectado del servidor ${evento.reason}`, 'error');
}

function webSocketMessageReceived(evento) {
  agregarMensaje(evento.data, 'normal');
}

function webSocketErrorOcurrido() {
  agregarMensaje('Error de conexión con el nodo verde', 'error');
}

function setupWebSocket() {
  const port = document.body.dataset.wsPort;
  webSocketServer = new WebSocket('ws://172.16.202.18:9000');

  webSocketServer.addEventListener('open', webSocketOpened);
  webSocketServer.addEventListener('message', webSocketMessageReceived);
  webSocketServer.addEventListener('error', webSocketErrorOcurrido);
  webSocketServer.addEventListener('close', webSocketClosed);
}

// Form -----------------------------------------------------------------------

function sendMessage() {
  const messageText = document.getElementById('message_field').value;
  const neighbor = document.querySelector('input[name="vecinos"]:checked').value;

  webSocketServer.send(`${neighbor}\t${messageText}`);
  agregarMensaje(`Para ${neighbor}: ${messageText}`, 'enviado');
}

function setupClient() {
  setupWebSocket();

  const button = document.getElementById('send_button');
  button.addEventListener('click', sendMessage);
}

window.addEventListener('load', setupClient);
