# sudo pip3 install autobahn[twisted,encryption,serialization]

from autobahn.twisted.websocket import WebSocketServerProtocol, \
    WebSocketServerFactory
import threading
import random

HOST = 'localhost'
PORT = 9000
ID_VERDE = 47
vecinosVivos = [13, 46, 52, 80, 103]

VOCALES = 'aeiou'
CONSONANTES = 'bcdfghjklmnpqrstvwxyz'

class WebSocketServer(WebSocketServerProtocol):
    
    def onConnect(self, request):
        print(f"Client connecting: {request.peer}")
    
    def onOpen(self):
        print("WebSocket connection open.")
        self.sendMessage(f"id\t{ID_VERDE}".encode('utf8'), False)
        self.sendMessage(f"vecinos\t{vecinosVivos}".encode('utf8'), False)
        self.generateMessage()

    def onMessage(self, payload, isBinary):
        if isBinary:
            print(f"Binary message received: {len(payload)} bytes")
        else:
            print(f"Text message received: {payload.decode('utf8')}")

        # echo back message verbatim
        # self.sendMessage(payload, isBinary)

    def onClose(self, wasClean, code, reason):
        print(f"WebSocket connection closed: {reason}")

    def generateMessage(self):
        fromNode = random.randint(0, 255)
        message = ''
        for word in range(random.randint(1, 10)):
            for syllable in range(random.randint(1, 3)):
                message += random.choice(CONSONANTES) + random.choice(VOCALES)
            message += ' '
        self.sendMessage(f"{fromNode}\t{message}".encode('utf8'), False)
        threading.Timer(random.randint(0,10), self.generateMessage).start()

if __name__ == '__main__':

    import sys

    from twisted.python import log
    from twisted.internet import reactor

    log.startLogging(sys.stdout)

    factory = WebSocketServerFactory(f"ws://{HOST}:{PORT}")
    factory.protocol = WebSocketServer
    # factory.setProtocolOptions(maxConnections=2)
    reactor.listenTCP(PORT, factory)
    reactor.run()
